
class LineDrawer {
    /**
     * 
     * @param {CanvasRenderingContext2D} ctx 
     */
    constructor(ctx) {
        this.ctx = ctx;
        this.lastColor = null;
    }

    beginPath() {
        this.ctx.beginPath();
    }

    /**
     * 
     * @param {number} x 
     * @param {number} y 
     */
    moveTo(x, y) {
        this.ctx.moveTo(x, y);
    }

    /**
     * 
     * @param {number} x 
     * @param {number} y 
     * @param {string} color
     */
    lineTo(x, y, color) {
        const ctx = this.ctx;
        ctx.lineTo(x, y);

        if (this.lastColor === null) {
            ctx.strokeStyle = color;
            this.lastColor = color;
        } else if (this.lastColor !== color) {
            ctx.stroke();
            ctx.strokeStyle = color;
            this.lastColor = color;
        }
    }
}

export {
    LineDrawer
}