'use strict';

const defaultElemento = {
    container:  ['div', { class: 'wd-container',    id: 'wd-container' }],
    grid:       ['div', { class: 'wd-grid',         id: 'wd-grid' }],
    view0:      ['div', { class: 'wd-view',         id: 'wd-view' }],
    values:     ['div', { class: 'wd-values',       id: 'wd-values' }],
    cursor:     ['div', { class: 'wd-cursor',       id: 'wd-cursor' }],
};

const defaultLayers = [
    'grid',
    'view0',
    'values',
    'cursor'
];

const createElemento = elemento => {
    const names = Object.keys(elemento);
    return names.reduce((res, name) => {
        const ml = elemento[name];
        const el = document.createElement(ml[0]);
        const attr = (typeof ml[1] === 'object') ? ml[1] : {};
        Object.keys(attr).map(key => {
            if (key === 'class') {
                el.classList.add(attr.class);
            } else {
                el.setAttribute(key, attr[key]);
            }
        });
        res[name] = el;
        return res;
    }, {});
};

const createContainer = (els, layers) => {
    layers.map(layer => els.container.appendChild(els[layer]));
    return els.container;
};

exports.defaultElemento = defaultElemento;
exports.defaultLayers = defaultLayers;
exports.createElemento = createElemento;
exports.createContainer = createContainer;

/* eslint-env browser */